<!-- 部门/负责人送检通知表格 -->
<script lang="ts" setup name="NotceList">
import { reactive, ref } from 'vue'
import { ElMessage, ElMessageBox } from 'element-plus'
import { getListPage } from '@/api/eqpt/measurementPlan/dept'
import useUserStore from '@/store/modules/user'
import { getUserDept } from '@/api/system/user'
const $props = defineProps({
  // notifyType 通知类型(负责人/部门，字典值)
  notifyType: {
    type: String,
    required: true,
  },
})
const $route = useRoute()
const { proxy } = getCurrentInstance() as any
const userStore = useUserStore()
const listQuery = reactive({
  notifyName: '', // 通知名称
  notifyNo: '', // 通知编号
  createTimeEnd: '',
  createTimeStart: '',
  notifyType: $props.notifyType, // 通知类型(负责人/部门，字典值)
  notifyDept: $route.path.includes('curatorpage') ? '' : userStore.deptId,
  notifyUser: $route.path.includes('curatorpage') ? userStore.id : '',
  offset: 1,
  limit: 20,
})
// 获取当前用户信息

// 开始结束时间
const datetimerange = ref()
watch(() => datetimerange.value, (newVal) => {
  listQuery.createTimeStart = ''
  listQuery.createTimeEnd = ''
  if (Array.isArray(newVal)) {
    if (newVal.length) {
      listQuery.createTimeStart = `${newVal[0]} 00:00:00`
      listQuery.createTimeEnd = `${newVal[1]} 23:59:59`
    }
  }
})

const columns = ref([
  {
    text: '通知编号',
    value: 'notifyNo',
    align: 'center',
  },
  {
    text: '通知名称',
    value: 'notifyName',
    align: 'center',
  },
  {
    text: '计划分类',
    value: 'planCategoryName',
    align: 'center',
  },
  {
    text: '创建单位',
    value: 'createDeptName',
    align: 'center',
  },
  {
    text: '创建人',
    value: 'createUserName',
    align: 'center',
  },
  {
    text: '创建时间',
    value: 'createTime',
    align: 'center',
  },
])
const list = ref([])
const total = ref(0)
const listLoading = ref(true)

// 获取数据
const fetchData = (isNowPage = true) => {
  // console.log(userStore.id, 'userStore.id')
  listLoading.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.offset = 1
  }
  getListPage(listQuery).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    listLoading.value = false
  })
}
fetchData()
// 查询数据
const search = () => {
  fetchData(false)
}
// 重置
const reset = () => {
  datetimerange.value = []
  listQuery.createTimeEnd = ''
  listQuery.notifyName = ''
  listQuery.notifyNo = ''
  listQuery.createTimeStart = ''
  listQuery.offset = 1
  listQuery.limit = 20
  search()
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size: number; page: number }) => {
  if (val && val.size) {
    listQuery.limit = val.size
  }
  if (val && val.page) {
    listQuery.offset = val.page
  }
  fetchData()
}
const $router = useRouter()
// 新建编辑操作
const handler = (row: any, type: string) => {
  $router.push({
    path: `/meteringdept/${type}`,
    query: {
      row: JSON.stringify(row),
      id: row.id,
    },
  })
}
</script>

<template>
  <app-container>
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="reset">
      <search-item>
        <el-input v-model.trim="listQuery.notifyNo" placeholder="通知编号" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.notifyName" placeholder="通知名称" clearable />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="datetimerange" type="daterange" value-format="YYYY-MM-DD"
          format="YYYY-MM-DD" range-separator="至" start-placeholder="创建开始时间" end-placeholder="创建结束时间"
        />
      </search-item>
    </search-area>
    <table-container>
      <template #btns-right>
        <!-- <icon-button icon="icon-add" title="新增" @click="handler({}, 'create')" /> -->
      </template>
      <!-- 普通表格 -->
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery" :list-loading="listLoading"
        :is-showmulti-select="true" @change="changePage"
      >
        <template #columns>
          <el-table-column label="操作" width="140" align="center">
            <template #default="scope">
              <el-button link type="primary" size="small" @click="handler(scope.row, 'detail')">
                查看
              </el-button>
              <!-- <el-button link type="primary" size="small" @click="handler(scope.row, 'update')">
                编辑
              </el-button>
              <el-button link type="danger" size="small" @click="delHandler(scope.row)">
                取消
              </el-button> -->
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
  </app-container>
</template>

